fixes and some improvements
[distro-setup] / brc
diff --git a/brc b/brc
index 5f43270c3c9e516864451eb357515db853756764..470c143f87a160b931ec323aeaff1840fbcc705f 100644 (file)
--- a/brc
+++ b/brc
@@ -278,9 +278,21 @@ mysrc /a/bin/distro-functions/src/package-manager-abstractions
 
 
 # * functions
-ccomp() { # copy completion
-  local src=$1
-  local c
+
+### begin FSF section ###
+
+# Comments before functions are meant to be good useful
+# documentation. If they fail at that, please improve them or send Ian a
+# note.
+
+## copy bash completion
+# Usage: ORIGINAL_COMMAND TARGET_COMMAND...
+#
+# It copies how the bash completion works from one command to other
+# commands.
+ccomp() {
+  local c src
+  src=$1
   shift
   if ! c=$(complete -p $src 2>/dev/null); then
     _completion_loader $src &>/dev/null ||:
@@ -292,6 +304,277 @@ ccomp() { # copy completion
   eval $c $*
 }
 
+## directory history tracking and navigation.
+#
+# cd becomes a function, also aliased to c. b to go back, f to go
+# forward, cl to list recent directories and choose one.
+#
+# The finer details you may want to skip:
+#
+# We also define bl to print the list of back and forward directories.
+#
+# We keep 2 stacks, forward and back. Unlike with a web browser, the
+# forward stack is not erased when going somewhere new.
+#
+# Recent directories are stored in ~/.cdirs.
+#
+declare -a _dir_forward _dir_back
+c() {
+  # normally, the top of _dir_back is our current dir. if it isn't,
+  # put it on there, except we don't want to do that when we
+  # just launched a shell
+  if [[ $OLDPWD ]]; then
+    if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
+      _dir_back+=("$PWD")
+    fi
+  fi
+  command cd "$@"
+  if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
+    _dir_back+=("$PWD")
+  fi
+  echo "$PWD" >> ~/.cdirs
+}
+ccomp cd c
+
+# back
+b() {
+  local top_back
+  if (( ${#_dir_back[@]} == 0 )); then
+    echo "nothing left to go back to" >&2
+    return 0
+  fi
+  top_back="${_dir_back[-1]}"
+
+  if [[ $top_back == "$PWD" ]] && (( ${#_dir_back[@]} == 1 )); then
+    echo "already on last back entry" >&2
+    return 0
+  fi
+
+
+  if [[ $top_back == "$PWD" ]]; then
+    # add to dirf if not already there
+    if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$top_back" ]]; then
+      _dir_forward+=("$top_back")
+    fi
+    unset "_dir_back[-1]"
+    command cd "${_dir_back[-1]}"
+  else
+    if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$PWD" ]]; then
+      _dir_forward+=("$PWD")
+    fi
+    command cd "$top_back"
+  fi
+
+  # Interesting feature, not sure I want it.
+  # give us a peek at what is next in the list
+  # if (( ${#_dir_back[@]} >= 2 )); then
+  #   printf "%s\n" "${_dir_back[-2]}"
+  # fi
+  #
+
+  # c/b/f Implementation notes:
+  #
+  # The top of the back is $PWD
+  # as long as the last directory change was due to c,b,or cl.
+  #
+  # Example of stack changes:
+  #
+  # a b c (d)
+  ## back
+  # a b (c)
+  # d
+  #back
+  #a (b)
+  #d c
+  #back
+  #(a)
+  #d c b
+  #forward
+  #a (b)
+  #d c
+  #
+  # a b c
+  ## back
+  # a b
+  # (c)
+  ## forward
+
+}
+# forward
+f() {
+  local top_forward
+  if (( ${#_dir_forward[@]} == 0 )); then
+    echo "no forward dir left" >&2
+    return 0
+  fi
+  top_forward="${_dir_forward[-1]}"
+  unset "_dir_forward[-1]"
+  c "$top_forward"
+
+  # give us a peek at what is next in the list
+  # if (( ${#_dir_forward[@]} )); then
+  #   printf "%s\n" "${_dir_forward[-1]}"
+  # fi
+}
+# cd list
+cl() {
+  local i line input start
+  local -A buttondirs alines
+  local -a buttons dirs lines
+  buttons=( {a..z} {2..9} )
+  if [[ ! -s ~/.cdirs ]]; then
+    echo nothing in ~/.cdirs
+    return 0
+  fi
+
+  i=0
+
+  mapfile -t lines <~/.cdirs
+  start=$(( ${#lines[@]} - 1 ))
+
+  # we have ~33 buttons as of this writing, so lets
+  # prune down the history every once in a while.
+  if (( start > 500 )); then
+    tac ~/.cdirs | awk '!seen[$0]++' | head -n 200 | sponge ~/.cdirs
+  fi
+
+  for (( j=$start; j >= 0; j-- )); do
+    line="${lines[$j]}"
+    if [[ ! $line || ${alines[$line]} || ! -d "$line" || $line == "$PWD" || line == "$HOME"  ]]; then
+      continue
+    fi
+    alines[$line]=t
+    buttondirs[${buttons[i]}]="$line"
+    printf "%s %s\n" ${buttons[i]} "$line"
+    if (( i == ${#buttons[@]} - 1 )); then
+      break
+    fi
+    i=$(( i + 1 ))
+  done
+
+  if (( i == 0 )); then
+    echo "no dirs in ~/.cdirs"
+    return 0
+  fi
+  read -r -N 1 input
+  if [[ $input != $'\n' ]]; then
+    c ${buttondirs[$input]}
+  fi
+}
+# back list
+bl() {
+  local start i j max
+  max=10
+  start=$(( ${#_dir_back[@]} - 1 ))
+
+  # cleanup possible repeating of pwd
+  if (( start >= 0 )) && [[ ${_dir_back[$start]} == "$PWD" ]]; then
+    start=$(( start - 1 ))
+  fi
+  j=1
+  if (( start >= 0 )); then
+    for (( i=$start; i >= 0 ; i-- )); do
+      printf "%s %s\n" $j ${_dir_back[i]}
+      j=$(( j + 1 ))
+      if (( j >= max )); then
+        break
+      fi
+    done
+  fi
+
+  max=10
+  start=$(( ${#_dir_forward[@]} - 1 ))
+
+  # cleanup possible repeating of pwd
+  if (( start >= 0 )) && [[ ${_dir_forward[$start]} == "$PWD" ]]; then
+    start=$(( start - 1 ))
+  fi
+  if (( start < 0 )); then
+    return 0
+  fi
+  echo --
+  j=1
+  for (( i=$start; i >= 0 ; i-- )); do
+    printf "%s %s\n" $j ${_dir_forward[i]}
+    j=$(( j + 1 ))
+    if (( j >= max )); then
+      break
+    fi
+  done
+}
+
+# pee do. run args as a command with output copied to syslog.
+#
+# Usage: pd [-t TAG] COMMAND...
+#
+# -t TAG Override the tag in the syslog. The default is COMMAND with
+#        any path part is removed, eg. for /bin/cat the tag is cat.
+#
+# You can view the log via "journalctl -t TAG"
+pd() {
+  local tag ret
+  ret=0
+  tag=${1##*/}
+  case $1 in
+    -t) tag="$2"; shift 2 ;;
+  esac
+  echo "PWD=$PWD command: $*" | logger -t $tag
+  "$@" |& pee cat "logger -t $tag" || ret=$?
+  echo "exited with status=$ret" | pee cat "logger -t $tag"
+  # this avoids any err-catch
+  (( $ret == 0 )) || return $ret
+}
+ccomp time pd
+
+# jdo = journal do. Run command as transient systemd service, tailing
+# its output in the journal until it completes.
+#
+# Usage: jdo COMMAND...
+#
+# Compared to pd: commands recognize this is a non-interactive shell.
+# The service is unaffected if our ssh connection dies, no need to run
+# in screen or tmux.
+#
+# Note: The last few lines of any existing entries for a unit by that
+# name will be output first, and there will be a few second delay at the
+# start of the command, and a second or so at the end.
+#
+# Note: Functions and aliases obviously won't work, we resolve the
+# command to a file.
+#
+# Note: requires running as root.
+jdo() {
+  local cmd cmd_name jr_pid ret
+  ret=0
+  cmd="$1"
+  shift
+  if [[ $EUID != 0 ]]; then
+    echo "jdo: error: rerun as root"
+    return 1
+  fi
+  cmd_name=${cmd##*/}
+  if [[ $cmd != /* ]]; then
+    cmd=$(type -P "$cmd")
+  fi
+  # -q = quiet
+  journalctl -qn2 -f -u "$cmd_name" &
+  # Trial and error of time needed to avoid missing initial lines.
+  # .5 was not reliable. 1 was not reliable. 2 was not reliable
+  sleep 4
+  jr_pid=$!
+  systemd-run --unit "$cmd_name" --wait --collect "$cmd" "$@" || ret=$?
+  # The sleep lets the journal output its last line
+  # before the prompt comes up.
+  sleep .5
+  kill $jr_pid &>/dev/null ||:
+  unset jr_pid
+  fg &>/dev/null ||:
+  # this avoids any err-catch
+  (( $ret == 0 )) || return $ret
+}
+ccomp time jdo
+#### end fsf section
+
 
 ..() { c ..; }
 ...() { c ../..; }
@@ -415,223 +698,26 @@ utcl() { # utc 24 hour time to local hour 24 hour time
   echo "print( ($1  $(date +%z | sed -r 's/..$//;s/^(-?)0*/\1/')) % 24)"|python3
 }
 
-declare -a _iankdirf _iankdirb
-
-
-# ## old wcd, to be deleted
-# b() {
-#   # backwards
-#   c -
-# }
-# # shellcheck disable=SC2032
-# f() {
-#   # cd forward
-#   c +
-# }
-# cl() {
-#   # choose recent directory. cl = cd list
-#   c =
-# }
-# # c. better cd
-# if ! type -t c &>/dev/null; then
-#   if type -p wcd &>/dev/null; then
-#     if [[ $LC_INSIDE_EMACS ]]; then
-#       c() { wcd -c -z 50 -o "$@"; }
-#     else
-#       # lets see what the fancy terminal does from time to time
-#       c() { wcd -c -z 50 "$@"; }
-#     fi
-#   else
-#     c() { cd "$@"; }
-#   fi
-# fi
-
-# c. better cd.
-# keep 2 stacks, forward and back. the top of the back is $PWD
-# as long as the last directory change was due to c,b,or cl.
-c() {
-  # normally, the top of dirb is our current dir. if it isn't,
-  # put it on there, except we don't want to do that when we
-  # just launched a shell
-  if [[ $OLDPWD ]]; then
-    if (( ${#_iankdirb[@]} == 0 )) || [[ ${_iankdirb[-1]} != "$PWD" ]]; then
-      _iankdirb+=("$PWD")
-    fi
-  fi
-  cd "$@"
-  if (( ${#_iankdirb[@]} == 0 )) || [[ ${_iankdirb[-1]} != "$PWD" ]]; then
-    _iankdirb+=("$PWD")
-  fi
-  echo "$PWD" >> ~/.iankdirs
-}
-ccomp cd c
-
 bwm() {
   s bwm-ng -T avg -d
 }
 
-b() {
-  local topb
-  if (( ${#_iankdirb[@]} == 0 )); then
-    echo "nothing left to go back to" >&2
-    return 0
-  fi
-  topb="${_iankdirb[-1]}"
 
-  if [[ $topb == "$PWD" ]] && (( ${#_iankdirb[@]} == 1 )); then
-    echo "already on last back entry" >&2
-    return 0
-  fi
-
-
-  if [[ $topb == "$PWD" ]]; then
-    # add to dirf if not already there
-    if (( ${#_iankdirf[@]} == 0 )) || [[ ${_iankdirf[-1]} != "$topb" ]]; then
-      _iankdirf+=("$topb")
-    fi
-    unset "_iankdirb[-1]"
-    cd "${_iankdirb[-1]}"
-  else
-    if (( ${#_iankdirf[@]} == 0 )) || [[ ${_iankdirf[-1]} != "$PWD" ]]; then
-      _iankdirf+=("$PWD")
-    fi
-    cd "$topb"
-  fi
-
-  # give us a peek at what is next in the list
-  # if (( ${#_iankdirb[@]} >= 2 )); then
-  #   printf "%s\n" "${_iankdirb[-2]}"
-  # fi
-}
-
-f() {
-  local topf
-  if (( ${#_iankdirf[@]} == 0 )); then
-    echo "no forward dir left" >&2
-    return 0
-  fi
-  topf="${_iankdirf[-1]}"
-  unset "_iankdirf[-1]"
-  c "$topf"
-
-  # give us a peek at what is next in the list
-  # if (( ${#_iankdirf[@]} )); then
-  #   printf "%s\n" "${_iankdirf[-1]}"
-  # fi
-}
-
-# a b c (d)
-## back
-# a b (c)
-# d
-#back
-#a (b)
-#d c
-#back
-#(a)
-#d c b
-#forward
-#a (b)
-#d c
-#
-# a b c
-## back
-# a b
-# (c)
-## forward
-
-cl() {
-  local i line input start tmpfile
-  local -A buttondirs alines
-  local -a buttons dirs lines
-  buttons=( {a..z} {2..9} )
-  if [[ ! -s ~/.iankdirs ]]; then
-    echo nothing in ~/.iankdirs
-    return 0
-  fi
-
-  i=0
-
-  # note, alternate approach like this, made the following read fail
-  # done < <(tac ~/.iankdirs | awk '!seen[$0]++')
-  # bash: read: read error: 0: Input/output error
-  # which went away by adding a sleep 1 after it.
-
-  mapfile -t lines <~/.iankdirs
-  start=$(( ${#lines[@]} - 1 ))
-
-  # we have ~33 buttons as of this writing, so lets
-  # prune down the history every once in a while.
-  if (( start > 500 )); then
-    tmpfile=$(mktemp)
-    tac ~/.iankdirs | awk '!seen[$0]++' | head -n 200 >$tmpfile
-    cat $tmpfile > ~/.iankdirs
-  fi
-
-  for (( j=$start; j >= 0; j-- )); do
-    line="${lines[$j]}"
-    if [[ ! $line || ${alines[$line]} || ! -d "$line" || $line == "$PWD" || line == "$HOME"  ]]; then
-      continue
-    fi
-    alines[$line]=t
-    buttondirs[${buttons[i]}]="$line"
-    printf "%s %s\n" ${buttons[i]} "$line"
-    if (( i == ${#buttons[@]} - 1 )); then
-      break
-    fi
-    i=$(( i + 1 ))
+# for running in a fai rescue
+kdrescue() {
+  d=vgata-Samsung_SSD_850_EVO_2TB_S2RLNX0J502123D
+  for f in $d vgata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V; do
+    cryptsetup luksOpen --key-file /p /dev/$f/root crypt-$f-root
+    cryptsetup luksOpen --key-file /p /dev/$f/o crypt-$f-o
   done
-
-  if (( i == 0 )); then
-    echo "no dirs in ~/.iankdirs"
-    return 0
-  fi
-  read -r -N 1 input
-  if [[ $input != $'\n' ]]; then
-    c ${buttondirs[$input]}
-  fi
+  mount -o subvol=root_trisquelaramo /dev/mapper/crypt-$d-root /mnt
+  mount -o subvol=a /dev/mapper/crypt-$d-root /mnt/a
+  mount -o subvol=o /dev/mapper/crypt-$d-o /mnt/o
+  mount -o subvol=boot_trisquelaramo /dev/sda2 /mnt/boot
+  cd /mnt
+  chrbind
 }
-bl() {
-  local start i j max
-  max=10
-  start=$(( ${#_iankdirb[@]} - 1 ))
 
-  # cleanup possible repeating of pwd
-  if (( start >= 0 )) && [[ ${_iankdirb[$start]} == "$PWD" ]]; then
-    start=$(( start - 1 ))
-  fi
-  j=1
-  if (( start >= 0 )); then
-    for (( i=$start; i >= 0 ; i-- )); do
-      printf "%s %s\n" $j ${_iankdirb[i]}
-      j=$(( j + 1 ))
-      if (( j >= max )); then
-        break
-      fi
-    done
-  fi
-
-  max=10
-
-  start=$(( ${#_iankdirf[@]} - 1 ))
-
-  # cleanup possible repeating of pwd
-  if (( start >= 0 )) && [[ ${_iankdirf[$start]} == "$PWD" ]]; then
-    start=$(( start - 1 ))
-  fi
-  if (( start < 0 )); then
-    return 0
-  fi
-  echo --
-  j=1
-  for (( i=$start; i >= 0 ; i-- )); do
-    printf "%s %s\n" $j ${_iankdirf[i]}
-    j=$(( j + 1 ))
-    if (( j >= max )); then
-      break
-    fi
-  done
-}
 
 
 
@@ -1200,9 +1286,13 @@ hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; d
 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
 # it\'s at ~/.config/hub
 hub() {
-  local up uptar updir p
-  p=/github/hub/releases/
-  up=https://github.com/$(curl -s https://github.com$p| grep -o $p'download/[^/]*/hub-linux-amd64[^"]*' | head -n1)
+  local up uptar updir p v
+  # example https://github.com/github/hub/releases/download/v2.14.2/hub-linux-amd64-2.14.2.tgz
+  up=$(wget -q -O- https://api.github.com/repos/github/hub/releases/latest | jq -r .assets[].browser_download_url | grep linux-amd64)
+  re='[[:space:]]'
+  if [[ ! $up || $up == $re ]]; then
+    echo "failed to get good update url. got: $up"
+  fi
   uptar=${up##*/}
   updir=${uptar%.tgz}
   if [[ ! -e /a/opt/$updir ]]; then
@@ -1230,6 +1320,21 @@ hub() {
 i() { git "$@"; }
 ccomp git i
 
+# git status:
+# cvs -qn update
+
+# git checkout FILE
+# cvs update -C FILE
+
+# git pull
+# cvs up[date]
+
+# potentially useful command translation
+# https://fling.seas.upenn.edu/~giesen/dynamic/wordpress/equivalent-commands-for-git-svn-and-cvs/
+
+# importing cvs repo into git using git-cvs package:
+# /f/www $ /usr/lib/git-core/git-cvsimport -C /f/www-git
+
 ic() {
   # fast commit all
   git commit -am "$*"
@@ -1266,6 +1371,10 @@ istext() {
   grep -Il "" "$@" &>/dev/null
 }
 
+pst() {
+  pstree -apnA
+}
+
 jtail() {
   journalctl -n 10000 -f "$@"
 }
@@ -1275,6 +1384,8 @@ jru() {
   journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
 }
 
+
+
 l() {
   if [[ $PWD == /[iap] ]]; then
     command ls -A --color=auto -I lost+found "$@"
@@ -1455,6 +1566,8 @@ nopanic() {
   ngreset
 }
 
+
+ping() { command ping -O "$@"; }
 p8() { ping "$@" 8.8.8.8; }
 p6() { ping6 "$@" 2001:4860:4860::8888; }
 
@@ -1534,6 +1647,7 @@ r() {
 scp() {
   rsync --inplace "$@"
 }
+ccomp rsync scp
 
 randport() {
   # available high ports are 1024-65535,
@@ -1570,8 +1684,9 @@ rst() {
   # rl without preserving modification time.
   rsync -ahvic --delete --no-t "$@"
 }
-rsu() { # [OPTS] HOST PATH
-  # eg. rlu -opts frodo /testpath
+# [RSYNC_OPTS] HOST PATH
+rsu() {
+  # eg. rsu -opts frodo /testpath
   # relative paths will expanded with readlink -f.
   opts=("${@:1:$#-2}") #  1 to last -2
   path="${*:$#}" # last
@@ -1579,10 +1694,7 @@ rsu() { # [OPTS] HOST PATH
   if [[ $path == .* ]]; then
     path=$(readlink -f $path)
   fi
-  # rync here uses checksum instead of time so we dont mess with
-  # unison relying on time as much. g is for group, same reason
-  # to keep up with unison.
-  m s rsync -rlpchviog --relative "${opts[@]}" "$path" "root@$host:/";
+  m rsync -ahvi --relative --no-implied-dirs "${opts[@]}" "$path" "root@$host:/";
 }
 ccomp rsync rsd rsa rst rsu
 
@@ -1644,6 +1756,11 @@ rmstrips() {
   ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
 }
 
+urun () {
+  umask $1
+  shift
+  "$@"
+}
 sudo () {
   command sudo "$@" || return $?
   DID_SUDO=true
@@ -1672,7 +1789,9 @@ sb() { # sudo bash -c
   local SUDOD="$PWD"
   sudo -i bash -c "$@"
 }
-ccomp sudo s sb
+# secret sudo
+se() { s urun 0077 "$@"; }
+ccomp sudo s sb se
 
 safe_rename() { # warn and dont rename if file exists.
   # mv -n exists, but it\'s silent
@@ -2380,15 +2499,6 @@ if [[ $- == *i* ]]; then
       history -a # save history
     fi
 
-    # assigned in brc2
-    # shellcheck disable=SC1303
-    if [[ $jr_pid ]]; then
-      if [[ -e /proc/$jr_pid ]]; then
-        kill $jr_pid
-      fi
-      unset jr_pid
-    fi
-
     case $return in
       0) ps_color="$term_purple"
          ps_char='\$'